#Region "options"
Option Strict Off
Option Explicit On
#End Region

#Region "imports"
Imports USB3Debugger.DeviceManagement
Imports USB3Debugger.FileIO
Imports USB3Debugger.Hid
Imports Microsoft.Win32.SafeHandles
Imports System.Globalization
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Timers
Imports VBLibraries.Utils.BaseUtility.Time
Imports VBLibraries.Communication
Imports VBLibraries.Utils.BaseUtility
Imports USB3Debugger.HIDCommand
Imports CyUSB
Imports USB3Debugger.VideoInterfaceModule.HRESULT
Imports USB3Debugger.GENIE1080PDetection
Imports System.Collections.Generic
'Imports VBLibraries.Utils.BaseUtility.Convert
#End Region

Friend Class FrmMain
    Inherits System.Windows.Forms.Form

#Region "Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
        CommandBuilder = New HIDCommand
    End Sub
    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            CommandBuilder = Nothing
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public ToolTip1 As System.Windows.Forms.ToolTip
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents RichTextBox1 As System.Windows.Forms.RichTextBox
    Public WithEvents btnReceive As System.Windows.Forms.Button
    Friend WithEvents txtSendBytes As System.Windows.Forms.TextBox
    Friend WithEvents btnDisconnect As System.Windows.Forms.Button
    Friend WithEvents btnConnect As System.Windows.Forms.Button
    Friend WithEvents GroupBox3 As System.Windows.Forms.GroupBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtFX3RegisterValue As System.Windows.Forms.TextBox
    Friend WithEvents txtFX3Register As System.Windows.Forms.TextBox
    Friend WithEvents btnSetFX3Register As System.Windows.Forms.Button
    Friend WithEvents btnGetFX3Register As System.Windows.Forms.Button
    Friend WithEvents Timer1 As System.Windows.Forms.Timer
    Friend WithEvents GroupBox12 As System.Windows.Forms.GroupBox
    Friend WithEvents ContextMenuStrip1 As System.Windows.Forms.ContextMenuStrip
    Friend WithEvents ToolStripMenuItem1 As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents ToolStripMenuItem2 As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents GroupBox14 As System.Windows.Forms.GroupBox
    Friend WithEvents TableLayoutPanel1 As System.Windows.Forms.TableLayoutPanel
    Friend WithEvents Label16 As System.Windows.Forms.Label
    Friend WithEvents lblFX3Version As System.Windows.Forms.Label
    Friend WithEvents Label18 As System.Windows.Forms.Label
    Friend WithEvents lblFPGAVersion As System.Windows.Forms.Label
    Friend WithEvents Label20 As System.Windows.Forms.Label
    Friend WithEvents lblEDIDVersion As System.Windows.Forms.Label
    Friend WithEvents Timer2 As System.Windows.Forms.Timer
    Friend WithEvents lblVideoInputDetection As System.Windows.Forms.Label
    Friend WithEvents Label22 As System.Windows.Forms.Label
    Friend WithEvents lblDeviceState As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents btnReset As System.Windows.Forms.Button
    Public WithEvents btnSend As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(FrmMain))
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.GroupBox1 = New System.Windows.Forms.GroupBox()
        Me.RichTextBox1 = New System.Windows.Forms.RichTextBox()
        Me.btnReceive = New System.Windows.Forms.Button()
        Me.txtSendBytes = New System.Windows.Forms.TextBox()
        Me.btnSend = New System.Windows.Forms.Button()
        Me.btnDisconnect = New System.Windows.Forms.Button()
        Me.btnConnect = New System.Windows.Forms.Button()
        Me.GroupBox3 = New System.Windows.Forms.GroupBox()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.txtFX3RegisterValue = New System.Windows.Forms.TextBox()
        Me.txtFX3Register = New System.Windows.Forms.TextBox()
        Me.btnSetFX3Register = New System.Windows.Forms.Button()
        Me.btnGetFX3Register = New System.Windows.Forms.Button()
        Me.Timer1 = New System.Windows.Forms.Timer(Me.components)
        Me.GroupBox12 = New System.Windows.Forms.GroupBox()
        Me.ContextMenuStrip1 = New System.Windows.Forms.ContextMenuStrip(Me.components)
        Me.ToolStripMenuItem1 = New System.Windows.Forms.ToolStripMenuItem()
        Me.ToolStripMenuItem2 = New System.Windows.Forms.ToolStripMenuItem()
        Me.GroupBox14 = New System.Windows.Forms.GroupBox()
        Me.TableLayoutPanel1 = New System.Windows.Forms.TableLayoutPanel()
        Me.lblDeviceState = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.lblVideoInputDetection = New System.Windows.Forms.Label()
        Me.Label22 = New System.Windows.Forms.Label()
        Me.Label16 = New System.Windows.Forms.Label()
        Me.lblFX3Version = New System.Windows.Forms.Label()
        Me.Label18 = New System.Windows.Forms.Label()
        Me.lblFPGAVersion = New System.Windows.Forms.Label()
        Me.lblEDIDVersion = New System.Windows.Forms.Label()
        Me.Label20 = New System.Windows.Forms.Label()
        Me.Timer2 = New System.Windows.Forms.Timer(Me.components)
        Me.btnReset = New System.Windows.Forms.Button()
        Me.GroupBox1.SuspendLayout()
        Me.GroupBox3.SuspendLayout()
        Me.GroupBox12.SuspendLayout()
        Me.ContextMenuStrip1.SuspendLayout()
        Me.GroupBox14.SuspendLayout()
        Me.TableLayoutPanel1.SuspendLayout()
        Me.SuspendLayout()
        '
        'GroupBox1
        '
        Me.GroupBox1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
            Or System.Windows.Forms.AnchorStyles.Left) _
            Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.GroupBox1.Controls.Add(Me.RichTextBox1)
        Me.GroupBox1.Controls.Add(Me.btnReceive)
        Me.GroupBox1.Controls.Add(Me.txtSendBytes)
        Me.GroupBox1.Controls.Add(Me.btnSend)
        Me.GroupBox1.Location = New System.Drawing.Point(0, 266)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(658, 190)
        Me.GroupBox1.TabIndex = 14
        Me.GroupBox1.TabStop = False
        Me.GroupBox1.Text = "Terminal"
        '
        'RichTextBox1
        '
        Me.RichTextBox1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
            Or System.Windows.Forms.AnchorStyles.Left) _
            Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.RichTextBox1.Location = New System.Drawing.Point(6, 45)
        Me.RichTextBox1.Name = "RichTextBox1"
        Me.RichTextBox1.Size = New System.Drawing.Size(658, 145)
        Me.RichTextBox1.TabIndex = 15
        Me.RichTextBox1.Text = ""
        '
        'btnReceive
        '
        Me.btnReceive.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnReceive.BackColor = System.Drawing.SystemColors.Control
        Me.btnReceive.Cursor = System.Windows.Forms.Cursors.Default
        Me.btnReceive.Enabled = False
        Me.btnReceive.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnReceive.ForeColor = System.Drawing.SystemColors.ControlText
        Me.btnReceive.Location = New System.Drawing.Point(586, 19)
        Me.btnReceive.Name = "btnReceive"
        Me.btnReceive.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.btnReceive.Size = New System.Drawing.Size(58, 20)
        Me.btnReceive.TabIndex = 14
        Me.btnReceive.Text = "RX"
        Me.btnReceive.UseVisualStyleBackColor = False
        '
        'txtSendBytes
        '
        Me.txtSendBytes.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
            Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtSendBytes.Location = New System.Drawing.Point(6, 19)
        Me.txtSendBytes.Name = "txtSendBytes"
        Me.txtSendBytes.Size = New System.Drawing.Size(511, 20)
        Me.txtSendBytes.TabIndex = 12
        '
        'btnSend
        '
        Me.btnSend.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnSend.BackColor = System.Drawing.SystemColors.Control
        Me.btnSend.Cursor = System.Windows.Forms.Cursors.Default
        Me.btnSend.Enabled = False
        Me.btnSend.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnSend.ForeColor = System.Drawing.SystemColors.ControlText
        Me.btnSend.Location = New System.Drawing.Point(523, 19)
        Me.btnSend.Name = "btnSend"
        Me.btnSend.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.btnSend.Size = New System.Drawing.Size(57, 20)
        Me.btnSend.TabIndex = 13
        Me.btnSend.Text = "TX"
        Me.btnSend.UseVisualStyleBackColor = False
        '
        'btnDisconnect
        '
        Me.btnDisconnect.Location = New System.Drawing.Point(12, 48)
        Me.btnDisconnect.Name = "btnDisconnect"
        Me.btnDisconnect.Size = New System.Drawing.Size(136, 30)
        Me.btnDisconnect.TabIndex = 16
        Me.btnDisconnect.Text = "Disconnect"
        '
        'btnConnect
        '
        Me.btnConnect.Location = New System.Drawing.Point(12, 12)
        Me.btnConnect.Name = "btnConnect"
        Me.btnConnect.Size = New System.Drawing.Size(136, 30)
        Me.btnConnect.TabIndex = 15
        Me.btnConnect.Text = "Connect"
        '
        'GroupBox3
        '
        Me.GroupBox3.Controls.Add(Me.Label2)
        Me.GroupBox3.Controls.Add(Me.Label1)
        Me.GroupBox3.Controls.Add(Me.txtFX3RegisterValue)
        Me.GroupBox3.Controls.Add(Me.txtFX3Register)
        Me.GroupBox3.Controls.Add(Me.btnSetFX3Register)
        Me.GroupBox3.Controls.Add(Me.btnGetFX3Register)
        Me.GroupBox3.Location = New System.Drawing.Point(13, 19)
        Me.GroupBox3.Name = "GroupBox3"
        Me.GroupBox3.Size = New System.Drawing.Size(129, 100)
        Me.GroupBox3.TabIndex = 16
        Me.GroupBox3.TabStop = False
        Me.GroupBox3.Text = "FX3 Register"
        '
        'Label2
        '
        Me.Label2.AutoSize = True
        Me.Label2.Location = New System.Drawing.Point(64, 25)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(34, 14)
        Me.Label2.TabIndex = 5
        Me.Label2.Text = "Value"
        '
        'Label1
        '
        Me.Label1.AutoSize = True
        Me.Label1.Location = New System.Drawing.Point(11, 25)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(47, 14)
        Me.Label1.TabIndex = 4
        Me.Label1.Text = "Register"
        '
        'txtFX3RegisterValue
        '
        Me.txtFX3RegisterValue.Location = New System.Drawing.Point(64, 42)
        Me.txtFX3RegisterValue.MaxLength = 10
        Me.txtFX3RegisterValue.Name = "txtFX3RegisterValue"
        Me.txtFX3RegisterValue.Size = New System.Drawing.Size(45, 20)
        Me.txtFX3RegisterValue.TabIndex = 3
        '
        'txtFX3Register
        '
        Me.txtFX3Register.Location = New System.Drawing.Point(13, 42)
        Me.txtFX3Register.MaxLength = 2
        Me.txtFX3Register.Name = "txtFX3Register"
        Me.txtFX3Register.Size = New System.Drawing.Size(45, 20)
        Me.txtFX3Register.TabIndex = 10
        Me.txtFX3Register.Text = "00"
        '
        'btnSetFX3Register
        '
        Me.btnSetFX3Register.Enabled = False
        Me.btnSetFX3Register.Location = New System.Drawing.Point(64, 68)
        Me.btnSetFX3Register.Name = "btnSetFX3Register"
        Me.btnSetFX3Register.Size = New System.Drawing.Size(45, 23)
        Me.btnSetFX3Register.TabIndex = 1
        Me.btnSetFX3Register.Text = "Set"
        Me.btnSetFX3Register.UseVisualStyleBackColor = True
        '
        'btnGetFX3Register
        '
        Me.btnGetFX3Register.Enabled = False
        Me.btnGetFX3Register.Location = New System.Drawing.Point(13, 68)
        Me.btnGetFX3Register.Name = "btnGetFX3Register"
        Me.btnGetFX3Register.Size = New System.Drawing.Size(45, 23)
        Me.btnGetFX3Register.TabIndex = 0
        Me.btnGetFX3Register.Text = "Get"
        Me.btnGetFX3Register.UseVisualStyleBackColor = True
        '
        'Timer1
        '
        Me.Timer1.Interval = 500
        '
        'GroupBox12
        '
        Me.GroupBox12.Controls.Add(Me.GroupBox3)
        Me.GroupBox12.Location = New System.Drawing.Point(6, 132)
        Me.GroupBox12.Name = "GroupBox12"
        Me.GroupBox12.Size = New System.Drawing.Size(186, 128)
        Me.GroupBox12.TabIndex = 23
        Me.GroupBox12.TabStop = False
        Me.GroupBox12.Text = "Register Access"
        '
        'ContextMenuStrip1
        '
        Me.ContextMenuStrip1.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.ToolStripMenuItem1, Me.ToolStripMenuItem2})
        Me.ContextMenuStrip1.Name = "ContextMenuStrip1"
        Me.ContextMenuStrip1.Size = New System.Drawing.Size(190, 48)
        Me.ContextMenuStrip1.Text = "Program"
        '
        'ToolStripMenuItem1
        '
        Me.ToolStripMenuItem1.Name = "ToolStripMenuItem1"
        Me.ToolStripMenuItem1.Size = New System.Drawing.Size(189, 22)
        Me.ToolStripMenuItem1.Text = "Program RAM"
        '
        'ToolStripMenuItem2
        '
        Me.ToolStripMenuItem2.Name = "ToolStripMenuItem2"
        Me.ToolStripMenuItem2.Size = New System.Drawing.Size(189, 22)
        Me.ToolStripMenuItem2.Text = "Program SPI EPPROM"
        '
        'GroupBox14
        '
        Me.GroupBox14.Controls.Add(Me.TableLayoutPanel1)
        Me.GroupBox14.Location = New System.Drawing.Point(173, 14)
        Me.GroupBox14.Name = "GroupBox14"
        Me.GroupBox14.Size = New System.Drawing.Size(330, 115)
        Me.GroupBox14.TabIndex = 25
        Me.GroupBox14.TabStop = False
        Me.GroupBox14.Text = "Device Info"
        '
        'TableLayoutPanel1
        '
        Me.TableLayoutPanel1.ColumnCount = 2
        Me.TableLayoutPanel1.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50.0!))
        Me.TableLayoutPanel1.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50.0!))
        Me.TableLayoutPanel1.Controls.Add(Me.lblDeviceState, 0, 0)
        Me.TableLayoutPanel1.Controls.Add(Me.Label3, 0, 0)
        Me.TableLayoutPanel1.Controls.Add(Me.lblVideoInputDetection, 0, 4)
        Me.TableLayoutPanel1.Controls.Add(Me.Label22, 0, 3)
        Me.TableLayoutPanel1.Controls.Add(Me.Label16, 0, 1)
        Me.TableLayoutPanel1.Controls.Add(Me.lblFX3Version, 1, 1)
        Me.TableLayoutPanel1.Controls.Add(Me.Label18, 0, 2)
        Me.TableLayoutPanel1.Controls.Add(Me.lblFPGAVersion, 1, 2)
        Me.TableLayoutPanel1.Controls.Add(Me.lblEDIDVersion, 1, 3)
        Me.TableLayoutPanel1.Controls.Add(Me.Label20, 0, 4)
        Me.TableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.TableLayoutPanel1.Location = New System.Drawing.Point(3, 16)
        Me.TableLayoutPanel1.Name = "TableLayoutPanel1"
        Me.TableLayoutPanel1.RowCount = 5
        Me.TableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50.0!))
        Me.TableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50.0!))
        Me.TableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20.0!))
        Me.TableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20.0!))
        Me.TableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20.0!))
        Me.TableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20.0!))
        Me.TableLayoutPanel1.Size = New System.Drawing.Size(324, 96)
        Me.TableLayoutPanel1.TabIndex = 0
        '
        'lblDeviceState
        '
        Me.lblDeviceState.AutoSize = True
        Me.lblDeviceState.Location = New System.Drawing.Point(165, 0)
        Me.lblDeviceState.Name = "lblDeviceState"
        Me.lblDeviceState.Size = New System.Drawing.Size(105, 14)
        Me.lblDeviceState.TabIndex = 9
        Me.lblDeviceState.Text = "Device Not Detected"
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(3, 0)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(55, 14)
        Me.Label3.TabIndex = 8
        Me.Label3.Text = "Device ID:"
        '
        'lblVideoInputDetection
        '
        Me.lblVideoInputDetection.AutoSize = True
        Me.lblVideoInputDetection.Location = New System.Drawing.Point(165, 76)
        Me.lblVideoInputDetection.Name = "lblVideoInputDetection"
        Me.lblVideoInputDetection.Size = New System.Drawing.Size(105, 14)
        Me.lblVideoInputDetection.TabIndex = 7
        Me.lblVideoInputDetection.Text = "Device Not Detected"
        '
        'Label22
        '
        Me.Label22.AutoSize = True
        Me.Label22.Location = New System.Drawing.Point(3, 56)
        Me.Label22.Name = "Label22"
        Me.Label22.Size = New System.Drawing.Size(72, 14)
        Me.Label22.TabIndex = 6
        Me.Label22.Text = "EDID Version:"
        '
        'Label16
        '
        Me.Label16.AutoSize = True
        Me.Label16.Location = New System.Drawing.Point(3, 18)
        Me.Label16.Name = "Label16"
        Me.Label16.Size = New System.Drawing.Size(69, 14)
        Me.Label16.TabIndex = 0
        Me.Label16.Text = "FX3 Version:"
        '
        'lblFX3Version
        '
        Me.lblFX3Version.AutoSize = True
        Me.lblFX3Version.Location = New System.Drawing.Point(165, 18)
        Me.lblFX3Version.Name = "lblFX3Version"
        Me.lblFX3Version.Size = New System.Drawing.Size(105, 14)
        Me.lblFX3Version.TabIndex = 1
        Me.lblFX3Version.Text = "Device Not Detected"
        '
        'Label18
        '
        Me.Label18.AutoSize = True
        Me.Label18.Location = New System.Drawing.Point(3, 36)
        Me.Label18.Name = "Label18"
        Me.Label18.Size = New System.Drawing.Size(77, 14)
        Me.Label18.TabIndex = 2
        Me.Label18.Text = "FPGA Version:"
        '
        'lblFPGAVersion
        '
        Me.lblFPGAVersion.AutoSize = True
        Me.lblFPGAVersion.Location = New System.Drawing.Point(165, 36)
        Me.lblFPGAVersion.Name = "lblFPGAVersion"
        Me.lblFPGAVersion.Size = New System.Drawing.Size(105, 14)
        Me.lblFPGAVersion.TabIndex = 3
        Me.lblFPGAVersion.Text = "Device Not Detected"
        '
        'lblEDIDVersion
        '
        Me.lblEDIDVersion.AutoSize = True
        Me.lblEDIDVersion.Location = New System.Drawing.Point(165, 56)
        Me.lblEDIDVersion.Name = "lblEDIDVersion"
        Me.lblEDIDVersion.Size = New System.Drawing.Size(105, 14)
        Me.lblEDIDVersion.TabIndex = 5
        Me.lblEDIDVersion.Text = "Device Not Detected"
        '
        'Label20
        '
        Me.Label20.AutoSize = True
        Me.Label20.Location = New System.Drawing.Point(3, 76)
        Me.Label20.Name = "Label20"
        Me.Label20.Size = New System.Drawing.Size(64, 14)
        Me.Label20.TabIndex = 4
        Me.Label20.Text = "Video Input:"
        '
        'Timer2
        '
        Me.Timer2.Interval = 1000
        '
        'btnReset
        '
        Me.btnReset.Location = New System.Drawing.Point(12, 84)
        Me.btnReset.Name = "btnReset"
        Me.btnReset.Size = New System.Drawing.Size(136, 30)
        Me.btnReset.TabIndex = 26
        Me.btnReset.Text = "Reset"
        '
        'FrmMain
        '
        Me.ClientSize = New System.Drawing.Size(658, 456)
        Me.Controls.Add(Me.btnReset)
        Me.Controls.Add(Me.btnConnect)
        Me.Controls.Add(Me.GroupBox1)
        Me.Controls.Add(Me.GroupBox14)
        Me.Controls.Add(Me.btnDisconnect)
        Me.Controls.Add(Me.GroupBox12)
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Location = New System.Drawing.Point(21, 28)
        Me.Name = "FrmMain"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "Generic HID Tester"
        Me.WindowState = System.Windows.Forms.FormWindowState.Maximized
        Me.GroupBox1.ResumeLayout(False)
        Me.GroupBox1.PerformLayout()
        Me.GroupBox3.ResumeLayout(False)
        Me.GroupBox3.PerformLayout()
        Me.GroupBox12.ResumeLayout(False)
        Me.ContextMenuStrip1.ResumeLayout(False)
        Me.GroupBox14.ResumeLayout(False)
        Me.TableLayoutPanel1.ResumeLayout(False)
        Me.TableLayoutPanel1.PerformLayout()
        Me.ResumeLayout(False)

    End Sub
#End Region

#Region "Constant"
    Private Const MAXIMUM_NUMBER_OF_LINE As ULong = 50000
    Private Const DISPLAY_DEBUG_ON_TEXT_BOX As Boolean = False
    Public ReadOnly ALLOWED_DEVICE As Guid = CLSID_GENIE1080P
    ' Public Const INOGENI_PNPID As String = "USB\VEN_04B4&DEV_00FA" ' NN TODO NN validated what the plug and play ID is for the GENIE1080p
    Public Const INOGENI_PNPID As String = "USB\VID_2997&PID_0001" ' NN TODO NN validated what the plug and play ID is for the GENIE1080p
    Public Const INOGENI_4K_PNPID As String = "USB\VID_2997&PID_0004" ' NN TODO NN validated what the plug and play ID is for the GENIE1080p
#End Region

#Region "Enums"
    Public Enum RequestType
        Read
        Write
        Unspecified
    End Enum
#End Region

#Region "Delegates"
    Private Delegate Sub AddStringToLog1Delegate(ByVal LineToLog As String, ByVal myTextColor As System.Drawing.Color)
    Private Delegate Sub enableButtonDelegate(ByVal Button As Button, ByVal Enable As Boolean)
    Private Delegate Sub enableComboBOxDelegate(ByVal cbx As ComboBox, ByVal Enable As Boolean)
    ' This delegate has the same parameters as AccessForm.
    ' Used in accessing the application's form from a different thread.

    Private Delegate Sub MarshalToForm _
     (ByVal action As String, _
     ByVal textToAdd As String)
#End Region

#Region "Control handler thread safe"
    ''' <summary>
    ''' Add a string to event log. Thread safe.
    ''' </summary>
    ''' <param name="Line">The line to written on the RichTextBox</param>
    ''' <param name="Color">The line color format</param>
    ''' <remarks></remarks>
    Private Sub AddStringToLog1(ByVal Line As String, ByVal Color As System.Drawing.Color)
        Try
            If EnableLog Then
                If RichTextBox1.InvokeRequired <> True Then
                    With RichTextBox1
                        If Len(.Text) > MAXIMUM_NUMBER_OF_LINE Then .Text = ""
                        .SelectionStart = Len(.Text)
                        .SelectionFont = New Font(.Font.FontFamily, .Font.Size, FontStyle.Bold)
                        .SelectionColor = Color.Black
                        .SelectedText = DisplayComputerTime(True) & ": "
                        .SelectionStart = Len(.Text)
                        .SelectionColor = Color
                        .SelectionFont = New Font(.Font.FontFamily, .Font.Size, FontStyle.Regular)
                        .SelectedText = Line & vbNewLine
                        .ScrollToCaret()
                    End With
                Else
                    RichTextBox1.BeginInvoke(New AddStringToLog1Delegate(AddressOf AddStringToLog1), Line, Color)
                End If
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return
        End Try
    End Sub

    Private Sub enableButton(ByVal Button As Button, ByVal Enable As Boolean)
        Try
            If Button IsNot Nothing AndAlso Button.InvokeRequired <> True Then
                Button.Enabled = Enable
            Else
                Button.BeginInvoke(New enableButtonDelegate(AddressOf enableButton), Button, Enable)
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return
        End Try
    End Sub

    Private Sub enableComboBox(ByVal cbx As ComboBox, ByVal Enable As Boolean)
        Try
            If cbx IsNot Nothing AndAlso cbx.InvokeRequired <> True Then
                cbx.Enabled = Enable
            Else
                cbx.BeginInvoke(New enableComboBOxDelegate(AddressOf enableComboBox), cbx, Enable)
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return
        End Try
    End Sub

#End Region

#Region "Private members"
    Private BootDetected As Boolean = False
    'USB cypress bootloader
    Private usbDevices As USBDeviceList
    Private myDevice As CyUSBDevice
    Private CyDeviceProgrammingInProgress As Boolean = False

    Private deviceNotificationHandle As IntPtr
    Private exclusiveAccess As Boolean
    Private fileStreamdevicedata As FileStream
    Private hidHandle As SafeFileHandle
    Private hidUsage As String
    Private myDeviceDetected As Boolean
    Private myDevicePathName As String
    Private transferInProgress As Boolean = False
    Private writeHandle As SafeFileHandle

    Private MyDebugging As New Debugging() ' For viewing results of API calls via Debug.Write.
    Private MyDeviceManagement As New DeviceManagement()
    Private MyHid As New Hid()

    Private Shared tmrReadTimeout As System.Timers.Timer
    Private Shared tmrContinuousDataCollect As System.Timers.Timer

    Friend FrmMy As FrmMain

    Private CommandBuilder As New HIDCommand

    Private EnableLog As Boolean = True
    Dim US3VendorId As String = "2997"
    Dim US3ProductId As String = "0001"
    Dim US34KProductId As String = "0004"
    Dim myVendorID As Int32 = Int32.Parse(US3VendorId, NumberStyles.AllowHexSpecifier)
    Dim myProductID As Int32 = Int32.Parse(US3ProductId, NumberStyles.AllowHexSpecifier)
    Dim my4KProductID As Int32 = Int32.Parse(US34KProductId, NumberStyles.AllowHexSpecifier)

    Dim EnableDebugConsoleWrite As Boolean = True
#End Region

    ''' <summary>
    ''' System timer timeout if read via interrupt transfer doesn't return.
    ''' </summary>
    ''' <param name="source"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>

    Private Sub OnReadTimeout(ByVal source As Object, ByVal e As ElapsedEventArgs)
        AddStringToLog1("The attempt to read a report timed out.", Color.Black)

        CloseCommunications()

        tmrReadTimeout.Stop()
    End Sub

    Private Sub EnableControl(ByVal Enable As Boolean)
        enableButton(btnSend, Enable)
        enableButton(btnReceive, Enable)
        enableButton(btnGetFX3Register, Enable)
        enableButton(btnSetFX3Register, Enable)
    End Sub

    ''' <summary>
    ''' Called when a WM_DEVICECHANGE message has arrived,
    ''' indicating that a device has been attached or removed.
    ''' </summary>
    ''' 
    ''' <param name="m"> a message with information about the device </param>

    Friend Sub OnDeviceChange(ByVal m As Message)

        '  DebugWriteLine("WM_DEVICECHANGE")

        Try
            If (m.WParam.ToInt32 = DBT_DEVICEARRIVAL) Then

                ' If WParam contains DBT_DEVICEARRIVAL, a device has been attached.

                DebugWriteLine("A device has been attached.")

                ' Find out if it's the device we're communicating with.

                If MyDeviceManagement.DeviceNameMatch(m, myDevicePathName) Then
                    AddStringToLog1("My device attached.", Color.Black)
                End If
                IsINOGENIPresent()

                ' FindTheHid()
            ElseIf (m.WParam.ToInt32 = DBT_DEVICEREMOVECOMPLETE) Then

                ' If WParam contains DBT_DEVICEREMOVAL, a device has been removed.

                DebugWriteLine("A device has been removed.")

                ' Find out if it's the device we're communicating with.

                If MyDeviceManagement.DeviceNameMatch(m, myDevicePathName) Then




                    AddStringToLog1("My device removed.", Color.Black)

                    ' Set MyDeviceDetected False so on the next data-transfer attempt,
                    ' FindTheHid() will be called to look for the device 
                    ' and get a new handle.

                    FrmMy.myDeviceDetected = False
                    'EnableControl(False)
                    'Shutdown()
                    'FindTheHid()
                End If
                If IsINOGENIPresent() = False Then

                End If
            ElseIf (m.WParam.ToInt32 = BT_DEVNODES_CHANGED) Then
                Console.WriteLine("A device has node changed.")
                'Ok there was a node change chek for the GENIE1080P

            End If



        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try
    End Sub

    ''' <summary>
    ''' Uses a series of API calls to locate a HID-class device
    ''' by its Vendor ID and Product ID.
    ''' </summary>
    '''         
    ''' <returns>
    '''  True if the device is detected, False if not detected.
    ''' </returns>

    Private Function FindTheHid(Optional ByVal logOndiscoveryOnly As Boolean = False) As Boolean

        Dim deviceFound As Boolean
        Dim devicePathName(127) As String
        Dim hidGuid As System.Guid
        Dim inputReportBuffer As Byte() = Nothing
        Dim memberIndex As Int32

        Dim outputReportBuffer As Byte() = Nothing
        Dim success As Boolean

        Try
            EnableControl(False)
            myDeviceDetected = False



            ' ***
            ' API function: 'HidD_GetHidGuid

            ' Purpose: Retrieves the interface class GUID for the HID class.

            ' Accepts: 'A System.Guid object for storing the GUID.
            ' ***

            HidD_GetHidGuid(hidGuid)

            DebugWriteLine(MyDebugging.ResultOfAPICall("GetHidGuid"))
            DebugWriteLine("  GUID for system HIDs: " & hidGuid.ToString)

            ' Fill an array with the device path names of all attached HIDs.

            deviceFound = MyDeviceManagement.FindDeviceFromGuid _
             (hidGuid, _
             devicePathName)

            ' If there is at least one HID, attempt to read the Vendor ID and Product ID
            ' of each device until there is a match or all devices have been examined.

            If deviceFound Then

                memberIndex = 0

                Do
                    ' ***
                    ' API function:
                    ' CreateFile

                    ' Purpose:
                    ' Retrieves a handle to a device.

                    ' Accepts:
                    ' A device path name returned by SetupDiGetDeviceInterfaceDetail
                    ' The type of access requested (read/write).
                    ' FILE_SHARE attributes to allow other processes to access the device while this handle is open.
                    ' A Security structure or IntPtr.Zero. 
                    ' A creation disposition value. Use OPEN_EXISTING for devices.
                    ' Flags and attributes for files. Not used for devices.
                    ' Handle to a template file. Not used.

                    ' Returns: a handle without read or write access.
                    ' This enables obtaining information about all HIDs, even system
                    ' keyboards and mice. 
                    ' Separate handles are used for reading and writing.
                    ' ***

                    ' Open the handle without read/write access to enable getting information about any HID, even system keyboards and mice.

                    hidHandle = CreateFile _
                     (devicePathName(memberIndex), _
                     0, _
                     FILE_SHARE_READ Or FILE_SHARE_WRITE, _
                     IntPtr.Zero, _
                     OPEN_EXISTING, _
                     0, _
                     0)

                    DebugWriteLine(MyDebugging.ResultOfAPICall("CreateFile"))
                    DebugWriteLine("  Returned handle: " & hidHandle.ToString)

                    If Not (hidHandle.IsInvalid) Then

                        ' The returned handle is valid, 
                        ' so find out if this is the device we're looking for.

                        ' Set the Size property of DeviceAttributes to the number of bytes in the structure.

                        MyHid.DeviceAttributes.Size = Marshal.SizeOf(MyHid.DeviceAttributes)

                        ' ***
                        ' API function:
                        ' HidD_GetAttributes

                        ' Purpose:
                        ' Retrieves a HIDD_ATTRIBUTES structure containing the Vendor ID, 
                        ' Product ID, and Product Version Number for a device.

                        ' Accepts:
                        ' A handle returned by CreateFile.
                        ' A pointer to receive a HIDD_ATTRIBUTES structure.

                        ' Returns:
                        ' True on success, False on failure.
                        ' ***

                        success = HidD_GetAttributes(hidHandle, MyHid.DeviceAttributes)

                        If success Then

                            DebugWriteLine("  HIDD_ATTRIBUTES structure filled without error.")
                            DebugWriteLine("  Structure size: " & MyHid.DeviceAttributes.Size)
                            DebugWriteLine("  Vendor ID: " & Hex(MyHid.DeviceAttributes.VendorID))
                            DebugWriteLine("  Product ID: " & Hex(MyHid.DeviceAttributes.ProductID))
                            DebugWriteLine("  Version Number: " & Hex(MyHid.DeviceAttributes.VersionNumber))

                            ' Find out if the device matches the one we're looking for.

                            If ((MyHid.DeviceAttributes.VendorID = myVendorID) And _
                             (MyHid.DeviceAttributes.ProductID = myProductID)) Or _
                                ((MyHid.DeviceAttributes.VendorID = myVendorID) And _
                             (MyHid.DeviceAttributes.ProductID = my4KProductID)) Then

                                DebugWriteLine("  My device detected")

                                ' Display the information in form's list box.

                                AddStringToLog1("Device detected:", Color.Black)
                                AddStringToLog1("  Vendor ID = " & Hex(MyHid.DeviceAttributes.VendorID), Color.Black)
                                AddStringToLog1("  Product ID = " & Hex(MyHid.DeviceAttributes.ProductID), Color.Black)




                                myDeviceDetected = True

                                ' Save the DevicePathName for OnDeviceChange().

                                myDevicePathName = devicePathName(memberIndex)
                                EnableControl(True)
                                Timer2.Enabled = True

                            Else

                                ' It's not a match, so close the handle.

                                myDeviceDetected = False

                                hidHandle.Close()
                                Timer2.Enabled = False

                            End If

                        Else
                            ' There was a problem in retrieving the information.

                            DebugWriteLine("  Error in filling HIDD_ATTRIBUTES structure.")
                            myDeviceDetected = False
                            hidHandle.Close()
                        End If

                    End If

                    ' Keep looking until we find the device or there are no devices left to examine.

                    memberIndex = memberIndex + 1

                Loop Until (myDeviceDetected Or (memberIndex = devicePathName.Length))

            End If

            If myDeviceDetected Then

                ' The device was detected.
                ' Register to receive notifications if the device is removed or attached.

                success = MyDeviceManagement.RegisterForDeviceNotifications _
                 (myDevicePathName, _
                 FrmMy.Handle, _
                 hidGuid, _
                 deviceNotificationHandle)

                DebugWriteLine("RegisterForDeviceNotifications = " & success)

                ' Learn the capabilities of the device.

                MyHid.Capabilities = MyHid.GetDeviceCapabilities(hidHandle)

                If success Then


                    AddStringToLog1("MyHid.Capabilities.OutputReportByteLength = " & MyHid.Capabilities.OutputReportByteLength, Color.Black)

                    ' Find out if the device is a system mouse or keyboard.

                    hidUsage = MyHid.GetHidUsage(MyHid.Capabilities)

                    ' Get the Input report buffer size.

                    GetInputReportBufferSize()


                    'Close the handle and reopen it with read/write access.

                    hidHandle.Close()


                    hidHandle = CreateFile _
                     (myDevicePathName, _
                     GENERIC_READ Or GENERIC_WRITE, _
                     FILE_SHARE_READ Or FILE_SHARE_WRITE, _
                     IntPtr.Zero, _
                     OPEN_EXISTING, _
                     0, _
                     0)

                    If hidHandle.IsInvalid Then

                        exclusiveAccess = True
                        AddStringToLog1("The device is a system " + hidUsage + ".", Color.Black)
                        AddStringToLog1("Windows 2000 and Windows XP obtain exclusive access to Input and Output reports for this devices.", Color.Black)
                        AddStringToLog1("Applications can access Feature reports only.", Color.Black)



                    Else

                        If (MyHid.Capabilities.InputReportByteLength > 0) Then

                            ' Set the size of the Input report buffer. 
                            ' Subtract 1 from the value in the Capabilities structure because 
                            ' the array begins at index 0.

                            Array.Resize(inputReportBuffer, MyHid.Capabilities.InputReportByteLength)

                            fileStreamdevicedata = New FileStream(hidHandle, FileAccess.Read Or FileAccess.Write, inputReportBuffer.Length, False)

                        End If

                        If (MyHid.Capabilities.OutputReportByteLength > 0) Then

                            ' Set the size of the Output report buffer. 
                            ' Subtract 1 from the value in the Capabilities structure because 
                            ' the array begins at index 0.

                            Array.Resize(outputReportBuffer, MyHid.Capabilities.OutputReportByteLength)

                        End If

                        ' Flush any waiting reports in the input buffer. (optional)

                        MyHid.FlushQueue(hidHandle)

                        Timer2.Enabled = True

                    End If
                End If
            Else
                ' The device wasn't detected.
                If logOndiscoveryOnly = False Then
                    AddStringToLog1("Device not found.", Color.Black)
                End If





                DebugWriteLine(" Device not found.")


            End If

            Return myDeviceDetected

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try
    End Function


    ''' <summary>
    ''' Uses a series of API calls to locate a HID-class device
    ''' by its Vendor ID and Product ID.
    ''' </summary>
    '''         
    ''' <returns>
    '''  True if the device is detected, False if not detected.
    ''' </returns>

    Private Function isDevicePresent() As Boolean

        Dim deviceFound As Boolean
        Dim devicePathName(127) As String
        Dim hidGuid As System.Guid
        Dim memberIndex As Int32
        Dim success As Boolean
        Dim hidHandle As SafeFileHandle = Nothing
        Try

            ' ***
            ' API function: 'HidD_GetHidGuid

            ' Purpose: Retrieves the interface class GUID for the HID class.

            ' Accepts: 'A System.Guid object for storing the GUID.
            ' ***

            HidD_GetHidGuid(hidGuid)

            DebugWriteLine(MyDebugging.ResultOfAPICall("GetHidGuid"))
            DebugWriteLine("  GUID for system HIDs: " & hidGuid.ToString)

            ' Fill an array with the device path names of all attached HIDs.

            deviceFound = MyDeviceManagement.FindDeviceFromGuid _
             (hidGuid, _
             devicePathName)

            ' If there is at least one HID, attempt to read the Vendor ID and Product ID
            ' of each device until there is a match or all devices have been examined.

            If deviceFound Then

                memberIndex = 0

                Do
                    ' ***
                    ' API function:
                    ' CreateFile

                    ' Purpose:
                    ' Retrieves a handle to a device.

                    ' Accepts:
                    ' A device path name returned by SetupDiGetDeviceInterfaceDetail
                    ' The type of access requested (read/write).
                    ' FILE_SHARE attributes to allow other processes to access the device while this handle is open.
                    ' A Security structure or IntPtr.Zero. 
                    ' A creation disposition value. Use OPEN_EXISTING for devices.
                    ' Flags and attributes for files. Not used for devices.
                    ' Handle to a template file. Not used.

                    ' Returns: a handle without read or write access.
                    ' This enables obtaining information about all HIDs, even system
                    ' keyboards and mice. 
                    ' Separate handles are used for reading and writing.
                    ' ***

                    ' Open the handle without read/write access to enable getting information about any HID, even system keyboards and mice.

                    hidHandle = CreateFile _
                     (devicePathName(memberIndex), _
                     0, _
                     FILE_SHARE_READ Or FILE_SHARE_WRITE, _
                     IntPtr.Zero, _
                     OPEN_EXISTING, _
                     0, _
                     0)



                    If Not (hidHandle.IsInvalid) Then

                        ' The returned handle is valid, 
                        ' so find out if this is the device we're looking for.

                        ' Set the Size property of DeviceAttributes to the number of bytes in the structure.

                        MyHid.DeviceAttributes.Size = Marshal.SizeOf(MyHid.DeviceAttributes)

                        ' ***
                        ' API function:
                        ' HidD_GetAttributes

                        ' Purpose:
                        ' Retrieves a HIDD_ATTRIBUTES structure containing the Vendor ID, 
                        ' Product ID, and Product Version Number for a device.

                        ' Accepts:
                        ' A handle returned by CreateFile.
                        ' A pointer to receive a HIDD_ATTRIBUTES structure.

                        ' Returns:
                        ' True on success, False on failure.
                        ' ***

                        success = HidD_GetAttributes(hidHandle, MyHid.DeviceAttributes)

                        If success Then

                            ' Find out if the device matches the one we're looking for.

                            If ((MyHid.DeviceAttributes.VendorID = myVendorID) And _
                             (MyHid.DeviceAttributes.ProductID = myProductID)) Or _
                            ((MyHid.DeviceAttributes.VendorID = myVendorID) And _
                             (MyHid.DeviceAttributes.ProductID = my4KProductID)) Then

                                'Yes our device is detected

                                Return True
                            Else

                                ' It's not a match, so close the handle.

                                hidHandle.Close()

                            End If

                        Else
                            ' There was a problem in retrieving the information.
                            hidHandle.Close()
                        End If

                    End If

                    ' Keep looking until we find the device or there are no devices left to examine.

                    memberIndex = memberIndex + 1

                Loop Until ((memberIndex = devicePathName.Length))
            End If
            Return False
        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        Finally
            If hidHandle IsNot Nothing Then
                hidHandle.Close()
            End If
        End Try
    End Function

    ''' <summary>
    ''' Search for a specific device.
    ''' </summary>
    Private Sub cmdFindDevice_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click

        Try
            ' Timer1.Enabled = False
            FindTheHid()

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        Finally
            If myDeviceDetected = False Then
                '    Timer1.Enabled = True
            End If
        End Try

    End Sub

    ''' <summary>
    ''' Close the handle and FileStreams for a device.
    ''' </summary>
    Private Sub CloseCommunications()

        If (Not (fileStreamdevicedata Is Nothing)) Then

            fileStreamdevicedata.Close()
        End If

        If ((Not (hidHandle Is Nothing)) AndAlso (Not hidHandle.IsInvalid)) Then

            hidHandle.Close()
        End If

        EnableControl(False)
        ' The next attempt to communicate will get new handles and FileStreams.

        myDeviceDetected = False


    End Sub

    ''' <summary>
    ''' Called if the user changes the Vendor ID or Product ID in the text box.
    ''' </summary>
    ''' 
    Private Sub DeviceHasChanged()

        Try
            ' If a device was previously detected, stop receiving notifications about it.

            If myDeviceDetected Then
                MyDeviceManagement.StopReceivingDeviceNotifications(deviceNotificationHandle)
            End If

            ' Search for the device the next time FindTheHid is called.

            myDeviceDetected = False

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try
    End Sub

    ''' <summary>
    ''' Sends an Output report, then retrieves an Input report.
    ''' Assumes report ID = 0 for both reports.
    ''' </summary>
    Private Sub SendReports()

        Dim byteValue As String
        Dim count As Int32
        Dim outputReportBuffer() As Byte = Nothing
        Dim success As Boolean

        Try
            success = False

            ' Don't attempt to exchange reports if valid handles aren't available
            ' (as for a mouse or keyboard under Windows 2000/XP.)

            If (Not (hidHandle.IsInvalid)) Then

                ' Don't attempt to send an Output report if the HID has no Output report.

                If (MyHid.Capabilities.OutputReportByteLength > 0) Then

                    ' Set the upper bound of the Output report buffer. 
                    ' Subtract 1 from OutputReportByteLength because the array begins at index 0.

                    Array.Resize(outputReportBuffer, MyHid.Capabilities.OutputReportByteLength)

                    ' Store the report ID in the first byte of the buffer:

                    outputReportBuffer(0) = 0

                    ' Store the report data following the report ID.
                    ' Use the data in the combo boxes on the form.
                    Dim Data As String = RemoveSpace(txtSendBytes.Text)

                    If Not IsHexadecimalString(Data.ToUpper) Then
                        MsgBox("Invalid hexadecimal string")
                        Return
                    End If
                    Dim MyArray As Byte() = Convert.StringOfHexToByteArray(Data.ToUpper)
                    Dim Len As Integer = outputReportBuffer.Length - 1

                    If MyArray.Length < Len Then
                        Len = MyArray.Length
                    End If
                    Array.Copy(MyArray, 0, outputReportBuffer, 1, Len)

                    ' Write a report.



                    ' If the HID has an interrupt OUT endpoint, the host uses an 
                    ' interrupt transfer to send the report. 
                    ' If not, the host uses a control transfer.

                    If (fileStreamdevicedata.CanWrite) Then
                        fileStreamdevicedata.Write(outputReportBuffer, 0, outputReportBuffer.Length)
                        success = True
                    Else
                        'CloseCommunications()
                        AddStringToLog1("The attempt to read an Input report has failed.", Color.Black)
                    End If


                    If success Then
                        If DISPLAY_DEBUG_ON_TEXT_BOX = True Then
                            AddStringToLog1("An Output report has been written.", Color.Black)

                            ' Display the report data in the form's list box.
                            AddStringToLog1(" Output Report ID: " & String.Format("{0:X2} ", outputReportBuffer(0)), Color.Black)
                            AddStringToLog1("An Output report has been written.", Color.Black)
                        End If


                        Dim Sent As String = "[TX]:"
                        For count = 1 To UBound(outputReportBuffer)

                            ' Display bytes as 2-character hex strings.

                            byteValue = String.Format("{0:X2}", outputReportBuffer(count))
                            Sent &= " " & byteValue
                        Next count
                        AddStringToLog1(Sent, Color.Red)

                    Else
                        'CloseCommunications()

                        AddStringToLog1("The attempt to write an Output report failed.", Color.Black)
                    End If
                Else
                    AddStringToLog1("The HID doesn't have an Output report.", Color.Black)
                End If

                ' Read an Input report.

                success = False
            Else
                AddStringToLog1("Invalid handle. The device is probably a system mouse or keyboard.", Color.Black)
                AddStringToLog1("No attempt to write an Output report or read an Input report was made.", Color.Black)
            End If


        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Sub


    ''' <summary>
    ''' retrieves an Input report.
    ''' Assumes report ID = 0 for both reports.
    ''' </summary>
    Private Sub ReceivedReports()

        Dim byteValue As String
        Dim count As Int32
        Dim inputReportBuffer() As Byte = Nothing
        Dim outputReportBuffer() As Byte = Nothing
        Dim success As Boolean

        Try
            success = False

            ' Don't attempt to exchange reports if valid handles aren't available
            ' (as for a mouse or keyboard under Windows 2000/XP.)

            If (Not (hidHandle.IsInvalid)) Then

                ' Read an Input report.

                success = False

                ' Don't attempt to send an Input report if the HID has no Input report.
                ' (The HID spec requires all HIDs to have an interrupt IN endpoint,
                ' which suggests that all HIDs must support Input reports.)

                If (MyHid.Capabilities.InputReportByteLength > 0) Then

                    ' Set the size of the Input report buffer. 
                    ' Subtract 1 from the value in the Capabilities structure because 
                    ' the array begins at index 0.

                    Array.Resize(inputReportBuffer, MyHid.Capabilities.InputReportByteLength)



                    ' Read a report using a control transfer.

                    success = MyHid.GetInputReportViaControlTransfer(hidHandle, inputReportBuffer)

                    If success Then
                        If DISPLAY_DEBUG_ON_TEXT_BOX = True Then
                            AddStringToLog1("An Input report has been read.", Color.Black)

                            ' Display the report data received in the form's list box.
                            AddStringToLog1(" Input Report ID: " & String.Format("{0:X2} ", inputReportBuffer(0)), Color.Black)
                            AddStringToLog1(" Input Report Data:", Color.Black)
                        End If


                        Dim RX As String = "[RX]:"
                        For count = 1 To UBound(inputReportBuffer)

                            ' Display bytes as 2-character Hex strings.

                            byteValue = String.Format("{0:X2} ", inputReportBuffer(count))
                            RX &= " " & byteValue

                            ' Display the received bytes in the text box.

                        Next count
                        AddStringToLog1(RX, Color.Blue)
                    Else
                        ' CloseCommunications()

                        AddStringToLog1("The attempt to read an Input report has failed.", Color.Black)
                    End If



                    ' Enable requesting another transfer.
                Else
                    AddStringToLog1("No attempt to read an Input report was made.", Color.Black)
                    AddStringToLog1("The HID doesn't have an Input report.", Color.Black)
                End If
            Else

                AddStringToLog1("Invalid handle. The device is probably a system mouse or keyboard.", Color.Black)
                AddStringToLog1("No attempt to write an Output report or read an Input report was made.", Color.Black)

            End If



        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Sub


    ''' <summary>
    ''' Perform shutdown operations.
    ''' </summary>
    Private Sub frmMain_Closed(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Closed

        Try
            Shutdown()

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try
    End Sub

    Private Sub usbDevices_DeviceRemoved(ByVal Sender As System.Object, ByVal e As System.EventArgs)
        Dim usbEvent As USBEventArgs = CType(e, USBEventArgs)

        RefreshCyUSBDeviceList()
    End Sub
    Private Sub usbDevices_DeviceAdded(ByVal Sender As System.Object, ByVal e As System.EventArgs)
        Dim usbEvent As USBEventArgs = CType(e, USBEventArgs)

        RefreshCyUSBDeviceList()
    End Sub

    Private Sub FrmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Timer1.Enabled = False
        Timer2.Enabled = False
    End Sub

    ''' <summary>
    ''' Perform startup operations.
    ''' </summary>

    Private Sub frmMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Try
            FrmMy = Me
            Me.Text = My.Application.Info.AssemblyName & String.Format(" (Version {0}.{1}.{2})", My.Application.Info.Version.Major, My.Application.Info.Version.Minor, My.Application.Info.Version.Build)
            Startup()
            'If FindTheHid() = False Then
            Timer1.Enabled = True
            'End If
            CyConst.SetClassGuid("{CDBF8987-75F1-468e-8217-97197F88F773}")
            usbDevices = New USBDeviceList(CyConst.DEVICES_CYUSB)
            AddHandler usbDevices.DeviceAttached, AddressOf usbDevices_DeviceAdded
            AddHandler usbDevices.DeviceRemoved, AddressOf usbDevices_DeviceRemoved
            RefreshCyUSBDeviceList()
        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Sub

    ''' <summary>
    ''' Finds and displays the number of Input buffers
    ''' (the number of Input reports the host will store). 
    ''' </summary>

    Private Sub GetInputReportBufferSize()

        Dim numberOfInputBuffers As Int32

        Try
            ' Get the number of input buffers.

            MyHid.GetNumberOfInputBuffers _
             (hidHandle, _
             numberOfInputBuffers)

            ' Display the result in the text box.



        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Sub

    ''' <summary>
    ''' Retrieves Input report data and status information.
    ''' This routine is called automatically when myInputReport.Read
    ''' returns. Calls several marshaling routines to access the main form.
    ''' </summary>
    ''' 
    ''' <param name="ar"> an object containing status information about 
    ''' the asynchronous operation. </param>

    Private Sub GetInputReportData(ByVal ar As IAsyncResult)

        Dim byteValue As String
        Dim count As Int32
        Dim inputReportBuffer As Byte() = Nothing

        Try
            inputReportBuffer = CType(ar.AsyncState, Byte())

            fileStreamdevicedata.EndRead(ar)

            tmrReadTimeout.Stop()

            ' Display the received report data in the form's list box.

            If (ar.IsCompleted) Then
                AddStringToLog1("An Input report has been read.", Color.Black)
                AddStringToLog1(" Input Report ID: " & String.Format("{0:X2} ", inputReportBuffer(0)), Color.Black)
                'AddStringToLog1(" Input Report Data:", Color.Black)


                Dim RX As String = "[RX]:"
                For count = 1 To UBound(inputReportBuffer)

                    ' Display bytes as 2-character Hex strings.
                    byteValue = String.Format("{0:X2} ", inputReportBuffer(count))
                    RX &= " " & byteValue

                Next count
                AddStringToLog1(RX, Color.Blue)

            Else
                AddStringToLog1("The attempt to read an Input report has failed.", Color.Black)
                Debug.Write("The attempt to read an Input report has failed")
            End If


            ' Enable requesting another transfer.


            transferInProgress = False

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Sub


    ''' <summary>
    ''' Initialize the elements on the form.
    ''' </summary>
    ''' 
    Private Sub InitializeDisplay()
        Try
            ' Create a dropdown list box for each byte to send in a report.
            ' Display the values as 2-character hex strings.


            ' Don't allow the user to select an input report buffer size until there is
            ' a handle to a HID.

            'cmdInputReportBufferSize.Focus()
            'cmdInputReportBufferSize.Enabled = False

            If MyHid.IsWindowsXpOrLater() = False Then

                ' If the operating system is earlier than Windows XP,
                ' disable the option to force Input and Output reports to use control transfers.

                AddStringToLog1("OOops We cannot force input and output reports", Color.Black)

            End If

            AddStringToLog1("***************************************************************************************", Color.Black)
            AddStringToLog1("For a more detailed event log, view debug statements in Visual Studio's Output window:", Color.Black)
            AddStringToLog1("Click Build > Configuration Manager > Active Solution Configuration > Debug > Close.", Color.Black)
            AddStringToLog1("Then click View > Output.", Color.Black)
            AddStringToLog1("***************************************************************************************", Color.Black)
        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Sub

    ''' <summary>
    ''' Initiates send report. 
    ''' The application sends a report.
    ''' </summary>
    Private Sub WriteToDevice()

        'Report header for the debug display:

        DebugWriteLine("")
        DebugWriteLine("***** HID Test Report *****")
        DebugWriteLine(Today & ": " & TimeOfDay)

        Try
            ' If the device hasn't been detected, was removed, or timed out on a previous attempt
            ' to access it, look for the device.

            If (myDeviceDetected = False) Then

                myDeviceDetected = FindTheHid()

            End If

            If (myDeviceDetected = True) Then
                ' An option button selects whether to exchange Input and Output reports
                ' or Feature reports.
                SendReports()
            End If

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Sub


    ''' <summary>
    ''' Initiates exchanging reports. 
    ''' The application sends a report and requests to read a report.
    ''' </summary>
    Private Sub ReadFromDevice()

        'Report header for the debug display:

        DebugWriteLine("")
        DebugWriteLine("***** HID Test Report *****")
        DebugWriteLine(Today & ": " & TimeOfDay)

        Try
            ' If the device hasn't been detected, was removed, or timed out on a previous attempt
            ' to access it, look for the device.

            If (myDeviceDetected = False) Then

                myDeviceDetected = FindTheHid()

            End If

            If (myDeviceDetected = True) Then
                ReceivedReports()
            End If

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Sub


    ''' <summary>
    ''' Perform actions that must execute when the program ends.
    ''' </summary>
    Private Sub Shutdown()

        Try
            CloseCommunications()

            ' Stop receiving notifications.

            MyDeviceManagement.StopReceivingDeviceNotifications(deviceNotificationHandle)
            EnableControl(False)
        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Sub

    ''' <summary>
    ''' Perform actions that must execute when the program starts.
    ''' </summary>
    Private Sub Startup()

        Try
            MyHid = New Hid()
            InitializeDisplay()



            tmrReadTimeout = New System.Timers.Timer(5000)
            AddHandler tmrReadTimeout.Elapsed, AddressOf OnReadTimeout
            tmrReadTimeout.SynchronizingObject = Me
            tmrReadTimeout.Stop()

            CommandBuilder = New HIDCommand

            ' Default USB Vendor ID and Product ID:



        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Sub

    ''' <summary>
    ''' Finalize method.
    ''' </summary>
    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub

    ''' <summary>
    '''  Overrides WndProc to enable checking for and handling WM_DEVICECHANGE messages.
    ''' </summary>
    ''' 
    ''' <param name="m"> a Windows Message </param>

    Protected Overrides Sub WndProc(ByRef m As Message)

        Try
            ' The OnDeviceChange routine processes WM_DEVICECHANGE messages.

            If m.Msg = WM_DEVICECHANGE Then
                OnDeviceChange(m)
            End If

            ' Let the base form process the message.

            MyBase.WndProc(m)

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Sub

    ''' <summary>
    ''' Provides a central mechanism for exception handling.
    ''' Displays a message box that describes the exception.
    ''' </summary>
    ''' 
    ''' <param name="moduleName"> the module where the exception occurred. </param>
    ''' <param name="e"> the exception </param>

    Shared Sub DisplayException(ByVal moduleName As String, ByVal e As Exception)

        Dim message As String
        Dim caption As String

        ' Create an error message.

        message = "Exception: " & e.Message & ControlChars.CrLf & _
        "Module: " & moduleName & ControlChars.CrLf & _
        "Method: " & e.TargetSite.Name

        caption = "Unexpected Exception"

        MessageBox.Show(message, caption, MessageBoxButtons.OK)
        Debug.Write(message)

    End Sub

    Private Sub btnSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSend.Click
        Try
            ' Don't allow another transfer request until this one completes.
            ' Move the focus away from cmdOnce to prevent the focus from 
            ' switching to the next control in the tab order on disabling the button.
            EnableControl(False)

            WriteToDevice()

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        Finally
            EnableControl(True)
        End Try
    End Sub

    Private Sub btnReceive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReceive.Click
        Try
            ' Don't allow another transfer request until this one completes.
            ' Move the focus away from cmdOnce to prevent the focus from 
            ' switching to the next control in the tab order on disabling the button.


            EnableControl(False)

            ReadFromDevice()

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        Finally
            EnableControl(True)
        End Try
    End Sub

    Private Sub btnDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisconnect.Click
        Try
            Timer2.Enabled = False
            Shutdown()

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try
    End Sub

#Region "Methods to handle HID Low level Report Communication"
    ''' <summary>
    ''' Sends an Output report, then retrieves an Input report.
    ''' Assumes report ID = 0 for both reports.
    ''' </summary>
    Private Function SendReports(ByVal ReportByte() As Byte) As Boolean

        Dim byteValue As String
        Dim count As Int32
        Dim outputReportBuffer() As Byte = Nothing
        Dim success As Boolean

        Try
            success = False

            If ReportByte Is Nothing OrElse ReportByte.Length < 1 Then
                Return False
            End If

            ' Don't attempt to exchange reports if valid handles aren't available
            ' (as for a mouse or keyboard under Windows 2000/XP.)

            If (Not (hidHandle.IsInvalid)) Then

                ' Don't attempt to send an Output report if the HID has no Output report.

                If (MyHid.Capabilities.OutputReportByteLength > 0) Then

                    ' Set the upper bound of the Output report buffer. 
                    ' Subtract 1 from OutputReportByteLength because the array begins at index 0.

                    Array.Resize(outputReportBuffer, MyHid.Capabilities.OutputReportByteLength)

                    ' Store the report ID in the first byte of the buffer:

                    outputReportBuffer(0) = 0


                    Dim Len As Integer = outputReportBuffer.Length - 1

                    If ReportByte.Length < Len Then
                        Len = ReportByte.Length
                    End If
                    Array.Copy(ReportByte, 0, outputReportBuffer, 1, Len)

                    ' Write a report.
                    ' If the HID has an interrupt OUT endpoint, the host uses an 
                    ' interrupt transfer to send the report. 
                    ' If not, the host uses a control transfer.

                    If (fileStreamdevicedata.CanWrite) Then
                        Try
                            fileStreamdevicedata.Write(outputReportBuffer, 0, outputReportBuffer.Length)
                            success = True
                        Catch ex As Exception
                            '  DisplayException(Me.Name, ex)
                            success = False
                        End Try
                    Else
                        CloseCommunications()
                        AddStringToLog1("The attempt to read an Input report has failed.", Color.Black)
                    End If


                    If success Then

                        AddStringToLog1("An Output report has been written.", Color.Black)

                        ' Display the report data in the form's list box.
                        AddStringToLog1(" Output Report ID: " & String.Format("{0:X2} ", outputReportBuffer(0)), Color.Black)
                        AddStringToLog1("An Output report has been written.", Color.Black)

                        Dim Sent As String = "[TX]:"
                        For count = 1 To UBound(outputReportBuffer)

                            ' Display bytes as 2-character hex strings.

                            byteValue = String.Format("{0:X2}", outputReportBuffer(count))
                            Sent &= " " & byteValue
                        Next count
                        AddStringToLog1(Sent, Color.Red)
                        Return True

                    Else
                        ' CloseCommunications()

                        AddStringToLog1("The attempt to write an Output report failed.", Color.Black)
                    End If
                Else
                    AddStringToLog1("The HID doesn't have an Output report.", Color.Black)
                End If

                ' Read an Input report.

                success = False
            Else
                AddStringToLog1("Invalid handle. The device is probably a system mouse or keyboard.", Color.Black)
                AddStringToLog1("No attempt to write an Output report or read an Input report was made.", Color.Black)
            End If
            Return False

        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Function
    ''' <summary>
    ''' Initiates exchanging reports. 
    ''' The application sends a report and requests to read a report.
    ''' </summary>
    Private Function ReadFromDevice(ByRef Answer() As Byte) As Boolean

        'Report header for the debug display:

        DebugWriteLine("")
        DebugWriteLine("***** HID Test Report *****")
        DebugWriteLine(Today & ": " & TimeOfDay)
        Answer = Nothing
        Try
            ' If the device hasn't been detected, was removed, or timed out on a previous attempt
            ' to access it, look for the device.

            If (myDeviceDetected = False) Then

                myDeviceDetected = FindTheHid()

            End If

            If (myDeviceDetected = True) Then
                Return ReceivedReports(Answer)
            End If
            Return False
        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Function
    ''' <summary>
    ''' retrieves an Input report.
    ''' Assumes report ID = 0 for both reports.
    ''' </summary>
    Private Function ReceivedReports(ByRef Answer() As Byte) As Boolean

        Dim byteValue As String
        Dim count As Int32
        Dim GetReport() As Byte = Nothing
        Dim success As Boolean

        Try
            success = False
            Answer = Nothing
            ' Don't attempt to exchange reports if valid handles aren't available
            ' (as for a mouse or keyboard under Windows 2000/XP.)

            If (Not (hidHandle.IsInvalid)) Then

                ' Read an Input report.

                success = False

                ' Don't attempt to send an Input report if the HID has no Input report.
                ' (The HID spec requires all HIDs to have an interrupt IN endpoint,
                ' which suggests that all HIDs must support Input reports.)

                If (MyHid.Capabilities.InputReportByteLength > 0) Then

                    ' Set the size of the Input report buffer. 
                    ' Subtract 1 from the value in the Capabilities structure because 
                    ' the array begins at index 0.

                    Array.Resize(GetReport, MyHid.Capabilities.InputReportByteLength)



                    ' Read a report using a control transfer.

                    success = MyHid.GetInputReportViaControlTransfer(hidHandle, GetReport)

                    If success Then
                        If DISPLAY_DEBUG_ON_TEXT_BOX = True Then
                            AddStringToLog1("An Input report has been read.", Color.Black)

                            ' Display the report data received in the form's list box.
                            AddStringToLog1(" Input Report ID: " & String.Format("{0:X2} ", GetReport(0)), Color.Black)
                            AddStringToLog1(" Input Report Data:", Color.Black)
                        End If


                        Dim RX As String = "[RX]:"
                        For count = 1 To UBound(GetReport)

                            ' Display bytes as 2-character Hex strings.

                            byteValue = String.Format("{0:X2} ", GetReport(count))
                            RX &= " " & byteValue

                            ' Display the received bytes in the text box.

                        Next count
                        AddStringToLog1(RX, Color.Blue)
                        Dim Len As Integer = GetReport.Length - 1
                        ReDim Answer(Len - 1)

                        'Ok carefull we don't care about byte 0
                        Array.Copy(GetReport, 1, Answer, 0, Len)
                        Return True
                    Else
                        'CloseCommunications()

                        AddStringToLog1("The attempt to read an Input report has failed.", Color.Black)
                    End If



                    ' Enable requesting another transfer.
                Else
                    AddStringToLog1("No attempt to read an Input report was made.", Color.Black)
                    AddStringToLog1("The HID doesn't have an Input report.", Color.Black)
                End If
            Else

                AddStringToLog1("Invalid handle. The device is probably a system mouse or keyboard.", Color.Black)
                AddStringToLog1("No attempt to write an Output report or read an Input report was made.", Color.Black)

            End If


            Return False
        Catch ex As Exception
            DisplayException(Me.Name, ex)
            Throw
        End Try

    End Function

    ''' <summary>
    ''' Exchange report with USB3 HID device
    ''' </summary>
    ''' <param name="Command"> The command as an array of byte to be send</param>
    ''' <param name="Answer">The byte recieve from the SUB3 device in the get report following the set report</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function ExchangeReport(ByVal Command() As Byte, ByRef Answer() As Byte) As Boolean
        Try
            If SendReports(Command) = True Then
                Return ReadFromDevice(Answer)
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return False
        End Try
    End Function
#End Region

#Region "USB3 HID high Level Request"
    Private Function ValidateHexStringisByte(ByVal HexString As String, ByRef Cleanup As String) As Boolean
        Try
            Dim temp As Double
            Cleanup = RemoveSpace(HexString.ToUpper)
            If IsHexadecimalString(Cleanup) = False Then
                Return False
            End If

            temp = CDbl("&H" & Cleanup)
            If temp < 0 OrElse temp > 255 Then
                Return False
            End If
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Private Function ValidateHexStringisUnsigned(ByVal HexString As String, ByRef Cleanup As String, ByVal Max As ULong) As Boolean
        Try
            Dim temp As Double
            Cleanup = RemoveSpace(HexString.ToUpper)
            If IsHexadecimalString(Cleanup) = False Then
                Return False
            End If

            temp = CDbl("&H" & Cleanup)
            If temp < 0 OrElse temp > Max Then
                Return False
            End If
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    ''' <summary>
    ''' Display in message box error code value
    ''' </summary>
    ''' <param name="code"></param>
    ''' <remarks></remarks>
    Private Sub MessageBoxHIDErrorCode(ByVal code As ErrorCode, Optional ByVal AccessType As RequestType = RequestType.Unspecified)
        Dim Message As String = "USB3 device return: "
        Select Case code
            Case ErrorCode.HID_ACK
                Message &= "Acknoledge."
            Case ErrorCode.HID_BAD_ADDR
                Message &= "Bad Address"
            Case ErrorCode.HID_BAD_CMD_NUM
                Message &= "Invalid commnad number"
            Case ErrorCode.HID_BAD_LENGTH
                Message &= "Invalid Primitive Length"
            Case ErrorCode.HID_BUSY
                Message &= "Busy"
            Case ErrorCode.HID_NO_RESPONSE_OR_INVALID
                Message = "No response receive from HID device or answer is invalid!"
            Case ErrorCode.HID_PC_EXCEPTION
                Message = "Application has encounter an unknown error"
            Case ErrorCode.HID_TOO_BAD
                Message &= "Too Bad"
            Case ErrorCode.HID_BAD_DATA_LENGTH
                Message &= "Bad Data request Length!"
            Case ErrorCode.HID_SPI_FAIL
                Message &= "SPI communication has failed!"
            Case ErrorCode.HID_I2C_NO_ANSWER
                Message &= "No answer received from target I2C device!"
            Case ErrorCode.HID_I2C_COMM_FAILED
                Message &= "I2C communication has failed!"
            Case ErrorCode.HID_NOT_SUPPORTED
                Message &= "This feature is currently not supported!"
            Case ErrorCode.HID_REG_ACCES_NOT_SUPPORTED
                If AccessType = RequestType.Read Then
                    Message &= "This register cannot be read!"
                ElseIf AccessType = RequestType.Write Then
                    Message &= "This register cannot be written."
                Else
                    Message &= "This request access type is not supported."
                End If
            Case ErrorCode.HID_FPGA_NOT_CONFIGURED
                Message &= "The FPGA does not appear to be configured!"
            Case Else
                Message = "Application has encounter an unknown error"
        End Select
        MsgBox(Message)
    End Sub

    ''' <summary>
    ''' Get FX3 register value
    ''' </summary>
    ''' <param name="Register">FX3 register value</param>
    ''' <param name="RegisterValue">Return the FX3 register value</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetFX3Register(ByVal Register As Byte, ByRef RegisterValue As Byte) As ErrorCode
        Try
            'Ok build a command to send to USB3 HID device
            Dim command() As Byte = CommandBuilder.BuildGetFX3Register(Register)
            Dim Answer() As Byte = Nothing
            If ExchangeReport(command, Answer) = True Then
                Dim Data() As Byte = Nothing
                Dim Result As ErrorCode = CommandBuilder.ParseDeviceAnswer(Answer, Data)
                If Result = ErrorCode.HID_ACK Then
                    RegisterValue = Data(0)
                End If
                Return Result
            Else
                Return ErrorCode.HID_NO_RESPONSE_OR_INVALID
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return ErrorCode.HID_PC_EXCEPTION
        End Try
    End Function

    ''' <summary>
    ''' Set FX3 register value
    ''' </summary>
    ''' <param name="Register">FX3 register number</param>
    ''' <param name="Value">FX3 register value</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function SetFX3Register(ByVal Register As Byte, ByVal Value As Byte) As ErrorCode
        Try
            'Ok build a command to send to USB3 HID device
            Dim command() As Byte = CommandBuilder.BuildSetFX3Register(Register, Value)
            Dim Answer() As Byte = Nothing
            If ExchangeReport(command, Answer) = True Then
                Return CommandBuilder.ParseDeviceAnswer(Answer)
            Else
                Return ErrorCode.HID_NO_RESPONSE_OR_INVALID
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
            Return ErrorCode.HID_PC_EXCEPTION
        End Try
    End Function

    ''' <summary>
    ''' Get video input frame rate
    ''' </summary>
    ''' <param name="frameRate"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetFrameRateFX3(ByRef frameRate As UShort) As Boolean
        Try
            frameRate = 0
            Dim Value As Byte

            Dim Response As ErrorCode = GetFX3Register(FX3Register.REG_FRAME_RATE_MSB, Value)

            If Response = ErrorCode.HID_ACK Then
                frameRate = (CUShort(Value) << 8)
            Else
                Return False
            End If

            Response = GetFX3Register(FX3Register.REG_FRAME_RATE_LSB, Value)

            If Response = ErrorCode.HID_ACK Then
                frameRate = frameRate + CUShort(Value)
                Return True
            Else
                Return False
            End If



            Return False
        Catch ex As Exception
            Return False
        End Try
    End Function
#End Region

    Private Sub btnSetFX3Register_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetFX3Register.Click
        Try
            Dim TempRegister As String = ""
            Dim TempValue As String = ""
            Dim temp As Double = 0
            Dim Register As Byte = 0
            Dim Value As Byte = 0

            'Validate
            'Validate
            If ValidateHexStringisByte(txtFX3Register.Text, TempRegister) = False Then
                MsgBox("Error The register must be a valid hexadecimal string from 0x00 to 0xFF")
                Return
            End If

            Register = CByte("&H" & TempRegister)

            If ValidateHexStringisByte(txtFX3RegisterValue.Text, TempValue) = False Then
                MsgBox("Error The register must be a valid hexadecimal string from 0x00 to 0xFF")
                Return
            End If

            Value = CByte("&H" & TempValue)

            Dim Response As ErrorCode = SetFX3Register(Register, Value)

            If Response = ErrorCode.HID_ACK Then
                'Ok
            Else
                MessageBoxHIDErrorCode(Response, RequestType.Write)
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Private Sub btnGetFX3Register_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetFX3Register.Click
        Try
            txtFX3RegisterValue.Text = ""
            Dim Temp As String = ""
            Dim Register As Byte = 0
            Dim Value As Byte = 0

            'Validate
            If ValidateHexStringisByte(txtFX3Register.Text, Temp) = False Then
                MsgBox("Error The register must be a valid hexadecimal string from 0x00 to 0xFF")
                Return
            End If

            Register = CByte("&H" & Temp)

            Dim Response As ErrorCode = GetFX3Register(Register, Value)

            If Response = ErrorCode.HID_ACK Then
                txtFX3RegisterValue.Text = String.Format("{0:X2}", Value)
            Else
                MessageBoxHIDErrorCode(Response, RequestType.Read)

            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim RestoreDebugConsoleWrite As Boolean = EnableDebugConsoleWrite
        Dim RestoreHIDDebug As Boolean = False

        Try

            If MyHid IsNot Nothing Then
                RestoreHIDDebug = MyHid.EnableLog
                MyHid.EnableLog = False
            End If
            EnableDebugConsoleWrite = False
            If isDevicePresent() Then
                enableButton(btnConnect, True)
                enableButton(btnDisconnect, True)
                RefreshCyUSBDeviceList()
                lblDeviceState.Text = String.Format("{0:X4}-{1:X2}", MyHid.DeviceAttributes.VendorID, MyHid.DeviceAttributes.ProductID)
                If myDeviceDetected Then
                    If Timer2.Enabled = False Then
                        Timer2.Enabled = True
                    End If
                Else
                    If Timer2.Enabled = True Then
                        Timer2.Enabled = False
                    End If
                End If


            Else
                If BootDetected = False Then

                End If

                If myDeviceDetected Then
                    RefreshCyUSBDeviceList()
                End If

                Timer2.Enabled = False
                EnableControl(False)
                enableButton(btnConnect, False)
                enableButton(btnDisconnect, False)
            End If
        Catch ex As Exception
        Finally
            EnableDebugConsoleWrite = RestoreDebugConsoleWrite
            If MyHid IsNot Nothing Then
                MyHid.EnableLog = RestoreHIDDebug
            End If
        End Try
    End Sub


#Region "Bootloader Methods"
    Private Sub RefreshCyUSBDeviceList()
        myDevice = Nothing

        For Each Device As USBDevice In usbDevices
            If Device IsNot Nothing Then
                BootDetected = True
            End If
        Next
        If BootDetected Then
            lblDeviceState.Text = "Bootloader Mode"
        Else
            If isDevicePresent() Then
                lblDeviceState.Text = String.Format("{0:X4}-{1:X2}", MyHid.DeviceAttributes.VendorID, MyHid.DeviceAttributes.ProductID)
            Else
                lblDeviceState.Text = "Device Not Detected"
            End If
        End If
    End Sub

#End Region

    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        Dim RestoreEnableLog As Boolean = EnableLog
        Dim RestoreDebugConsoleWrite As Boolean = EnableDebugConsoleWrite
        Dim RestoreHIDDebug As Boolean = False

        Try
            If MyHid IsNot Nothing Then
                RestoreHIDDebug = MyHid.EnableLog
                MyHid.EnableLog = False
            End If
            Dim Major As Byte = 0
            Dim Minor As Byte = 0
            Dim Temp As String = "FX3 Not Detected"
            Dim VideoInput As USB3Debugger.HIDCommand.VideoFormat
            Dim value As Byte = 0

            EnableLog = False
            EnableDebugConsoleWrite = False
            Dim Response As ErrorCode = ErrorCode.HID_NO_RESPONSE_OR_INVALID
            If isDevicePresent() Then
                Response = GetFX3Register(FX3Register.VersionMajor, Major)

                If Response = ErrorCode.HID_ACK Then
                    Response = GetFX3Register(FX3Register.VersionMinor, Minor)
                    If Response = ErrorCode.HID_ACK Then
                        Temp = String.Format("{0}.{1}", Major, Minor)
                    Else
                        Dim stophere As Boolean = True
                    End If
                End If

                Response = GetFX3Register(FX3Register.REG_Reserved, value)

                If Response = ErrorCode.HID_ACK Then

                    If (value And &H2) = 0 Then
                        If Temp = "" Then
                            Temp = "Device not initialised"
                        Else
                            Temp = Temp & " (Device not initialised)"
                        End If
                    End If
                End If

            End If
            If Response <> ErrorCode.HID_BUSY Then
                lblFX3Version.Text = Temp
            End If

            Response = ErrorCode.HID_NO_RESPONSE_OR_INVALID

            'FPGA version
            Temp = "FPGA Not Detected"
            Response = GetFX3Register(FX3Register.FPGAVersion, value)

            If Response = ErrorCode.HID_ACK AndAlso value <> &HFF Then
                'Display
                Temp = String.Format("{0}.{1}", ((value And &HF0) >> 4), value And &HF)
            End If
            lblFPGAVersion.Text = Temp

            'Video Format
            Temp = "Device Not Detected"
            If isDevicePresent() Then
                Response = GetVideoInputFX3(VideoInput)

                If Response = ErrorCode.HID_ACK Then
                    If VideoInput.Locked Then
                        Temp = String.Format("{0}x{1}", VideoInput.ActivesPixel, VideoInput.ActiveLinesF0)
                    Else
                        Temp = "No Input"
                    End If
                ElseIf Response = ErrorCode.HID_NOT_SUPPORTED Then
                    Temp = "HDMI Receiver not Detected!"
                Else
                    Dim stopthere As Boolean = True
                End If
            End If

            If Response <> ErrorCode.HID_BUSY Then
                Dim FrameRate As UShort = 0

                If VideoInput.Locked AndAlso GetFrameRateFX3(FrameRate) AndAlso FrameRate > 0 Then
                    'Ok add the frame rate
                    Temp &= String.Format("@{0:#.##}", CDbl(FrameRate / 100))
                End If

                lblVideoInputDetection.Text = Temp
            End If

            'EDID version
            Temp = "Device Not Detected"
            If isDevicePresent() Then
                Response = GetFX3Register(FX3Register.EDID_VERSION, value)

                If Response = ErrorCode.HID_ACK Then
                    If value >= 4 Then
                        Temp = String.Format("{0}", value)
                    Else
                        Temp = "Unknown"
                    End If

                Else
                    Dim stopthere As Boolean = True
                End If
            End If
            lblEDIDVersion.Text = Temp

        Catch ex As Exception
        Finally
            EnableLog = RestoreEnableLog
            EnableDebugConsoleWrite = RestoreDebugConsoleWrite
            If MyHid IsNot Nothing Then
                MyHid.EnableLog = RestoreHIDDebug
            End If
        End Try
    End Sub

    Public Function GetVideoInputFX3(ByRef VideoInput As USB3Debugger.HIDCommand.VideoFormat) As ErrorCode
        Try
            VideoInput.ActiveLinesF0 = 0
            VideoInput.ActivesPixel = 0
            VideoInput.Locked = 0
            Dim Value As Byte

            Dim Response As ErrorCode = GetFX3Register(FX3Register.REG_WIDTH_MSB, Value)

            If Response = ErrorCode.HID_ACK Then
                VideoInput.ActivesPixel = (CUShort(Value) << 8)
            Else
                Return Response
            End If


            Response = GetFX3Register(FX3Register.REG_WIDTH_LSB, Value)
            If Response = ErrorCode.HID_ACK Then
                VideoInput.ActivesPixel = VideoInput.ActivesPixel + Value
            Else
                Return Response
            End If

            Response = GetFX3Register(FX3Register.REG_HEIGHT_MSB, Value)
            If Response = ErrorCode.HID_ACK Then
                VideoInput.ActiveLinesF0 = (CUShort(Value) << 8)
            Else
                Return Response
            End If

            Response = GetFX3Register(FX3Register.REG_HEIGHT_LSB, Value)
            If Response = ErrorCode.HID_ACK Then
                VideoInput.ActiveLinesF0 = VideoInput.ActiveLinesF0 + Value
            Else
                Return Response
            End If

            Response = GetFX3Register(FX3Register.REG_VIDEO_GENERAL, Value)
            If Response = ErrorCode.HID_ACK Then
                If Value And &H1 Then
                    VideoInput.Locked = 1
                Else
                    VideoInput.Locked = 0
                End If
            Else
                Return Response
            End If


            Return Response
        Catch ex As Exception

        End Try
    End Function

    Public Sub DebugWriteLine(ByVal message As String)
        If EnableDebugConsoleWrite Then
            Debug.WriteLine(message)
        End If
    End Sub

    ''' <summary>
    ''' Check if the INOGENI is connected to the system.
    ''' </summary>
    ''' <returns>
    ''' Return true if the INOGENI is detected in the system.
    ''' </returns>
    ''' <remarks></remarks>
    Public Shared Function IsINOGENIPresent() As Boolean
        Try
            Dim Devices As List(Of Device) = Device.GetAllDevices()
            If Devices IsNot Nothing Then
                For Each dev As Device In Devices
                    If (dev.PNPDeviceID.Contains(INOGENI_PNPID) Or dev.PNPDeviceID.Contains(INOGENI_4K_PNPID)) Then
                        Return True
                    End If
                Next
            End If
            Return False
        Catch ex As Exception
            'MsgBox(ex.ToString)
        End Try
    End Function

    Public Sub ResetFX3()
        Try

            'Reset the device
            SetFX3Register(&HFF, 1)
            Wait(2000)

            Dim timeout As ULong = GetTickCount() + 10000
            Dim DeviceDetected As Boolean = False

            While (DeviceDetected = False AndAlso GetTickCount() < timeout)
                DeviceDetected = isDevicePresent()
                Wait(50) ' Do not take all cpu power and refresh gui
            End While

            If (DeviceDetected = False) Then
                MsgBox("Device Failed to reboot!")
                Return
            End If

            'Connect
            Try
                FindTheHid()

            Catch ex As Exception
                DisplayException(Me.Name, ex)
                Return
            Finally
                If myDeviceDetected = False Then
                    '    Timer1.Enabled = True
                End If
            End Try
        Catch ex As Exception

        End Try
    End Sub

    Private Sub btnReset_Click(sender As System.Object, e As System.EventArgs) Handles btnReset.Click
        ResetFX3()
    End Sub
End Class
